package iteriere;
import static iteriere.LL.*;
public class TestLLSchleife {
	static <E> LL<E> reverse(LL<E> list){
		var loop = new LLSchleife<E>(list);
		class B<A>{A x;B(A y){x=y;} }
		B<LL<E>> rs = new B<>(LL.nil());
		loop.run(it -> rs.x = LL.cons(it, rs.x));
		return rs.x;
	}
	static <E> LL<E> reverse2(LL<E> xs){
		LL<E> rs = LL.nil();
		for (var x:xs) {
			rs = LL.cons(x, rs);
		}
		return rs;
	}
	public static void main(String[] args) {
		var xs = of (1,2,3,4,5,6,7,8,9);
		System.out.println(reverse2(xs));
		System.out.println(xs.appendIt(of(17,4)));
	}
}
